//////////////////////////////////////////////////////////////////////////
//
// CWifi - helper class for Access Point listing
//
// Coded by dzolee
// http://dzolee.blogspot.com
//
//////////////////////////////////////////////////////////////////////////

#include <Windows.h>
#include <winioctl.h>
#include <NtDDNdis.h>
#include <nuiouser.h>
#include "Common.h"

#if _MSC_VER > 1000
#pragma once
#endif

//basid BSSID info struct
struct BSSIDInfo
{
	BYTE BSSID[6];	//mac
	WCHAR SSID[32];
	int RSSI;
	int Channel;
	int Infastructure;
	int Auth;
};

class CWifi
{
public:
	CWifi();
	~CWifi();

	bool GetAdapters(LPWSTR pDest, DWORD &dwBufSizeBytes);
	bool RefreshBSSIDs(LPWSTR pAdapter);
	bool GetBSSIDs(LPWSTR pAdapter, struct BSSIDInfo *pDest, DWORD &dwBufSizeBytes, DWORD &dwReturnedItems);	
	bool SetAdHocConnection(LPWSTR pAdapter, LPSTR pSsid);
	bool SetConnectionMode(LPWSTR pAdapter, NDIS_802_11_NETWORK_INFRASTRUCTURE iMode, NDIS_802_11_AUTHENTICATION_MODE aMode);
	bool SetSsid(LPWSTR pAdapter, LPCSTR pSsid);
	bool GetBSSID(LPWSTR pAdapter, LPWSTR pSsid, struct BSSIDInfo *pDest);
	bool SetWPAKey(LPWSTR pAdapter, struct BSSIDInfo *pBssid, BYTE* pKey, UINT uKeyLen);
	bool CheckAssociation(LPWSTR pAdapter, LPCSTR pSsid);

private:
	bool OpenDriver();
	void CloseDriver();

	CRITICAL_SECTION m_Lock;
	HANDLE m_hNDUIO;
};

